% script for testing transforms

clear all, close all

disp(' '), disp('figA')
pappos=[2 2 6 2]
figure(1), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;

fax=linspace(-1,1,401);
dfax=2/400*ones(1,401); 
dfax([1 end])=dfax([1 end])/2;
T=5
leak1=(sin(pi*fax*T)/pi./fax).^2/T; nleak1=trapz(fax,leak1)
leak2=(sin(pi*fax*T)./sin(pi*fax)).^2/T; nleak2=trapz(fax,leak2), nleak2-2
subplot(1,2,1)
plot(fax,leak1,'-','linewidth',10), xlim([-1 1]), set(gca,'XTick',-1:.5:1)
xlabel('f_\Delta','fontsize',fsze); ylabel('L_T(f_\Delta)','fontsize',fsze);
subplot(1,2,2)
plot(fax,leak2,'-','linewidth',10), xlim([-1 1]), set(gca,'XTick',-1:.5:1)
xlabel('f_\Delta','fontsize',fsze); ylabel('L_T(f_\Delta)','fontsize',fsze);

for ks=1:2, subplot(1,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 2 0 -2.5]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figA.eps')
system('epstopdf figA.eps');
delete temp.eps

clear all, close all

disp(' '), disp('figB')
pappos=[2 2 6 2]
figure(1), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;

N=4, P=0, 
nf=2*N+P, f=([1:nf]-(nf+1)/2)/2/N, 
df=ones(1,nf); df([1 end])=df([1 end])-P/2; 
df=df/2/N, delf=df(2)/2, %sum(df)
subplot(1,2,1)
plot([f-delf;f-delf;f+delf;f+delf],[0*df;df;df;0*df],'b-','linewidth',5)
xlim([-1/2-eps 1/2+eps]), ylim([0 .2]), hold on
plot(f,df,'bx','linewidth',5), hold off
xlabel('f','fontsize',fsze), ylabel('\Delta_f','fontsize',fsze), title('N = 4, P = 0','fontsize',fsze)
N=4, P=1, 
nf=2*N+P, f=([1:nf]-(nf+1)/2)/2/N, 
df=ones(1,nf); df([1 end])=df([1 end])-P/2; 
df=df/2/N, delf=df(2)/2, %sum(df)
fmdelf=max([f-delf],-1/2); fpdelf=min([f+delf],1/2);
subplot(1,2,2)
delfl=delf+0*df; delfl(1)=0;
delfr=delf+0*df; delfr(end)=0;
plot([f-delfl;f-delfl;f+delfr;f+delfr],[0*df;df;df;0*df],'b-','linewidth',5)
xlim([-1/2-eps 1/2+eps]), ylim([0 .2]), hold on
plot(f,df,'bx','linewidth',5), hold off
xlabel('f','fontsize',fsze), ylabel('\Delta_f','fontsize',fsze), title('N = 4, P = 1','fontsize',fsze)

for ks=1:2, subplot(1,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze,'XTick',-.5:.25:.5)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 1.25 0 -2.5]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figB.eps')
system('epstopdf figB.eps');
delete temp.eps

clear all, close all

disp(' '), disp('figC')
pappos=[2 2 6 4]
figure(1), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;

nd=20, tax=1:nd; 
%tax=cumsum(round(3*rand(1,nd)))+tax; tax=tax-tax(1)+1; % make tax gapped
nt=tax(end)
nq=2, fq=[.025; .25]
%fq=sort(rand(nq,1)*.5)
fq=fq*(1+.00*cos(2*pi*tax/nt));
aq=2*pi*rand(nq,1)*ones(1,nd);
yt=sum(cos(aq+2*pi*fq.*tax(ones(1,nq),:)),1);
yt=yt(:); yt=yt/sqrt(sum(yt.^2));
myt=mean(yt)
sumyt2=sum(yt.^2)
Nmin=ceil(nt/2)

N=nd, foff=0, 
nf0=N+0, fax0=([1:nf0]-(0+1)/2)/2/N+foff; % 0 to 1/2
dfax0=ones(1,nf0)/2/N;
nf1=N+1, fax1=([1:nf1]-(1+1)/2)/2/N+foff; % 0 to 1/2
dfax1=ones(1,nf1); 
dfax1([1 end])=dfax1([1 end])-1/2;  
dfax1=dfax1/2/N;
sax0=1./fax0; dsax0=-diff(1./fax1);
sax1=1./fax1; dsax1=-diff(1./[fax1(1) fax0 fax1(end)]);
dfds0=dfax0./dsax0; dfds1=dfax1./dsax1;
[sum(dfax0) sum(dfax1) sum(dsax0) sum(dsax1)]
theta0=sqrt(2)*exp(i*2*pi*tax'*fax0);   % basis functions
theta1=sqrt(2)*exp(i*2*pi*tax'*fax1);   % basis functions
yfax0=theta0'*yt; ysax0=sqrt(dfds0').*yfax0;
yfax1=theta1'*yt; ysax1=sqrt(dfds1').*yfax1;
pwrfax0=abs(yfax0).^2; pwrfax1=abs(yfax1).^2;
pwrsax0=abs(ysax0).^2; pwrsax1=abs(ysax1).^2;
totpwr=[sumyt2 dfax0*pwrfax0 dfax1*pwrfax1 dsax0*pwrsax0 dsax1*pwrsax1];
format long, totpwr, format short
subplot(2,2,1)
%plot(fax1,pwrfax1,'x-','linewidth',5), xlim([0 1/2])
delfl=1/4/N+0*fax1; delfl(1)=0;
delfr=1/4/N+0*fax1; delfr(end)=0;
plot([fax1-delfl;fax1-delfl;fax1+delfr;fax1+delfr],[0*fax1;pwrfax1';pwrfax1';0*fax1],'b-','linewidth',5)
xlim([0-eps 1/2+eps]), ylim([0 2*ceil(max(pwrfax1)/2)]), hold on
plot(fax1,pwrfax1,'bx','linewidth',5), hold off
xlabel('f','fontsize',fsze), ylabel('|y_f|^2','fontsize',fsze), 
subplot(2,2,2)
%plot(sax1,pwrsax1,'x-','linewidth',5), xlim([2 20]), ylim([0 1])
plot(1./[fax1-delfl;fax1-delfl;fax1+delfr;fax1+delfr],[0*sax1;pwrsax1';pwrsax1';0*sax1],'b-','linewidth',5)
xlim([2-eps 2*sax1(2)+eps]), ylim([0 1]), hold on
plot(sax1,pwrsax1,'bx','linewidth',5), hold off
set(gca,'XTick',[2 get(gca,'XTick')])
xlabel('s','fontsize',fsze), ylabel('|y_s|^2','fontsize',fsze), 

N=nd, foff=1/2, 
nf0=N+0, fax0=([1:nf0]-(0+1)/2)/2/N+foff; % 0 to 1/2
dfax0=ones(1,nf0)/2/N;
nf1=N+1, fax1=([1:nf1]-(1+1)/2)/2/N+foff; % 0 to 1/2
dfax1=ones(1,nf1); 
dfax1([1 end])=dfax1([1 end])-1/2;  
dfax1=dfax1/2/N;
sax0=1./fax0; dsax0=-diff(1./fax1);
sax1=1./fax1; dsax1=-diff(1./[fax1(1) fax0 fax1(end)]);
dfds0=dfax0./dsax0; dfds1=dfax1./dsax1;
[sum(dfax0) sum(dfax1) sum(dsax0) sum(dsax1)]
theta0=sqrt(2)*exp(i*2*pi*tax'*fax0);   % basis functions
theta1=sqrt(2)*exp(i*2*pi*tax'*fax1);   % basis functions
yfax0=theta0'*yt; ysax0=sqrt(dfds0').*yfax0;
yfax1=theta1'*yt; ysax1=sqrt(dfds1').*yfax1;
pwrfax0=abs(yfax0).^2; pwrfax1=abs(yfax1).^2;
pwrsax0=abs(ysax0).^2; pwrsax1=abs(ysax1).^2;
totpwr=[sumyt2 dfax0*pwrfax0 dfax1*pwrfax1 dsax0*pwrsax0 dsax1*pwrsax1];
format long, totpwr, format short
subplot(2,2,3)
%plot(fax1,pwrfax1,'x-','linewidth',5), xlim([1/2 1])
delfl=1/4/N+0*fax1; delfl(1)=0;
delfr=1/4/N+0*fax1; delfr(end)=0;
plot([fax1-delfl;fax1-delfl;fax1+delfr;fax1+delfr],[0*fax1;pwrfax1';pwrfax1';0*fax1],'b-','linewidth',5)
xlim([1/2-eps 1+eps]), ylim([0 2*ceil(max(pwrfax1)/2)]), hold on
plot(fax1,pwrfax1,'bx','linewidth',5), hold off
xlabel('f','fontsize',fsze), ylabel('|y_f|^2','fontsize',fsze), 
subplot(2,2,4)
%plot(sax1,pwrsax1,'x-','linewidth',5), xlim([1 2])
plot(1./[fax1-delfl;fax1-delfl;fax1+delfr;fax1+delfr],[0*sax1;pwrsax1';pwrsax1';0*sax1],'b-','linewidth',5)
xlim([1-eps 2+eps]), ylim([0 2*ceil(max(pwrfax1)/2)]), hold on
plot(sax1,pwrsax1,'bx','linewidth',5), hold off
xlabel('s','fontsize',fsze), ylabel('|y_s|^2','fontsize',fsze), 

for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figC.eps')
system('epstopdf figC.eps');
delete temp.eps


