% script for testing one sided transforms

clear all, close all

diary off
dfile='figsec3n4.txt'
delete(dfile)
diary(dfile)

%% convolution indices
%P=0, N=3, M=2*N+1, m=1:M, fm=(m-N-1)/2/N, mp=M+1-m, n=1:M-1+P
%for np=n, npm(np,:)=mod(np-1+m-N-1,2*N)+1; end, npm
%P=1, N=3, M=2*N+1, m=1:M, fm=(m-N-1)/2/N, mp=M+1-m, n=1:M-1+P
%for np=n, npm(np,:)=mod(np-1+m-N-1,2*N)+1; end, npm

% signal generation

nd=200, tax=1:nd; 
%tax=cumsum(round(3*rand(1,nd)))+tax; tax=tax-tax(1)+1; % make tax gapped
nt=tax(end)
nq=4
%fq=sort(rand(nq,1)*.5)
fq=linspace(.05,.30,nq)';
aq=2*pi*rand(nq,1)*ones(1,nd);
fq=fq(:,ones(1,nd)).*(1+.05*cos(aq+2*pi*tax(ones(1,nq),:)/nd));
fq(fq>1/2)=1-fq(fq>1/2); fq(fq<0)=-fq(fq<0);
aq=2*pi*rand(nq,1)*ones(1,nd);
shoax=round(linspace(1,nt,41)); shoax=shoax(1:2:41);
yt=sum(cos(aq+2*pi*fq.*tax(ones(1,nq),:)),1);
myt=mean(yt)
sumyt2=sum(yt.^2)

pf = 0
nf = nt
nff = nf+pf

save -6 savesig.mat     % save for section 5

figure(1), clf

format long
[yf1,fax1,dfax1]=osdfourier(1,yt,tax,nf,pf);
pwryf1=abs(yf1).^2; phsyf1=angle(yf1);
iyf1=osdfourier(-1,yf1,tax,nf,pf);
resyf1=(iyf1.'-yt); rmsresyf1=sqrt(mean(resyf1.^2))
[sum(iyf1.^2) dfax1*pwryf1 sumyt2], ans(2:3)./ans(1:2), 1./ans
format short

format long
[yf2,fax2,dfax2]=tsdfourier(1,yt,tax,nf,pf);
pwryf2=abs(yf2).^2; phsyf2=angle(yf2);
iyf2=real(tsdfourier(-1,yf2,tax,nf,pf));
resyf2=(iyf2.'-yt); rmsresyf2=sqrt(mean(resyf2.^2))
[sum(iyf2.^2) dfax2*pwryf2 sumyt2], ans(2:3)./ans(1:2), 1./ans
format short

subplot(2,2,1), plot(fax1,pwryf1,'s-'), xlim([0 1/2])
subplot(2,2,2), semilogy(tax,abs(resyf1),'s-')
subplot(2,2,3), plot(fax2,pwryf2,'s-'), xlim([-1/2 1/2])
subplot(2,2,4), semilogy(tax,abs(resyf2),'s-')

pappos=[2 2 6 4]
figure(6), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;
subplot(2,2,1), plot(fax1,pwryf1,'bx','markersize',4,'linewidth',5), xlim([0 1/2])
ylim([0 2000*ceil(max(pwryf1)/2000)]), set(gca,'YTick',0:2000:max(ylim))

disp(' '), disp('figD')
pappos=[2 2 6 4]
figure(2), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;

format long
sigma = sqrt(pi)*2, tau = 6*2
[yg,fax,dfax,phi]=osdgabor(1,yt,tax,nf,sigma,tau,pf);
pwryg=abs(yg).^2; phsyg=angle(yg);
iyg=osdgabor(-1,yg,tax,nf,sigma,tau,pf);
resyg=(iyg-yt); rmsresyg=sqrt(mean(resyg.^2))
totpwr=[sumyt2 dfax*sum(pwryg,2) sum(iyg.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),1:length(phi),nf,1); 
pwrphif2=abs(phif2).^2; 
cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
convpwrf=cvp(nf*3+[1:nff])*2;
convpwrt=conv(phi.^2/2,yt.^2);

taxtau=1-tau:nt+tau;
subplot(2,2,1), [cp,ch]=contour(taxtau,fax,pwryg); axis([1-tau nt+tau 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)
subplot(2,2,2), ph=plot(sum(pwryg,2),fax,'bx',convpwrf,fax,'r+'); ylim([0 1/2]), 
xlim([0 300*ceil(max(sum(pwryg,2))/300)]), set(gca,'XTick',0:300:max(xlim))
xlabel('P(f)','fontsize',fsze), ylabel('f','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,3), ph=plot(taxtau,dfax*pwryg,'bx',taxtau,convpwrt,'r+'); xlim([1-tau nt+tau])
xlabel('t','fontsize',fsze), ylabel('P(t)','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,4), semilogy(tax,abs(resyg),'bx-','markersize',4,'linewidth',5), ylim([1e-17 1e-14])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figD.eps')
system('epstopdf figD.eps');
delete temp.eps

figure(6), 
subplot(2,2,2), plot(fax,sum(pwryg,2),'bx','markersize',4,'linewidth',5), xlim([0 1/2])
ylim([0 300*ceil(max(sum(pwryg,2))/300)]), set(gca,'YTick',0:300:max(ylim))

disp(' '), disp('figE')
pappos=[2 2 6 4]
figure(3), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;

format long
sigma = sigma/2, tau = tau/2, om1=1
[ym,fax,dfax,taumax]=osdmorlet(1,yt,tax,nf,sigma,tau,pf,om1);
pwrym=abs(ym).^2; phsym=angle(ym);
iym=osdmorlet(-1,ym,tax,nf,sigma,tau,pf,om1);
resym=(iym-yt); rmsresym=sqrt(mean(resym.^2))
totpwr=[sumyt2 dfax*sum(pwrym,2) sum(iym.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short

taxtau=1-taumax:nt+taumax;
subplot(2,2,1), [cp,ch]=contour(taxtau,fax,pwrym); axis([1-tau*2 nt+tau*2 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)
subplot(2,2,2), ph=plot(sum(pwrym,2),fax,'bx'); ylim([0 1/2])
xlim([0 1000*ceil(max(sum(pwrym,2))/1000)]), set(gca,'XTick',0:1000:max(xlim))
xlabel('P(f)','fontsize',fsze), ylabel('f','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,3), ph=plot(taxtau,dfax*pwrym,'bx'); xlim([1-tau*2 nt+tau*2])
xlabel('t','fontsize',fsze), ylabel('P(t)','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,4), semilogy(tax,abs(resym),'bx-','markersize',4,'linewidth',5), ylim([1e-4 1e-1])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figE.eps')
system('epstopdf figE.eps');
delete temp.eps

figure(6), 
subplot(2,2,3), plot(fax,sum(pwrym,2),'bx','markersize',4,'linewidth',5), xlim([0 1/2])
ylim([0 1000*ceil(max(sum(pwrym,2))/1000)]), set(gca,'YTick',0:1000:max(ylim))

disp(' '), disp('figF')
pappos=[2 2 6 4]
figure(4), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;

% subtract the signal mean
format long
yt=yt-myt; sumyt2=sum(yt.^2)
[ym,fax,dfax,taumax]=osdmorlet(1,yt,tax,nf,sigma,tau,pf,om1);
pwrym=abs(ym).^2; phsym=angle(ym);
iym=osdmorlet(-1,ym,tax,nf,sigma,tau,pf,om1);
resym=(iym-yt); rmsresym=sqrt(mean(resym.^2))
totpwr=[sumyt2 dfax*sum(pwrym,2) sum(iym.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
outtab(:,1)=[rmsresym totpwrrat-1]';
subplot(2,2,1), semilogy(tax,abs(resym),'bx-','markersize',4,'linewidth',5), ylim([1e-4 1e-1])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

% invert power ratios
coff=sqrt(prod(totpwrrat))
iym=iym/coff;
resym=(iym-yt); rmsresym=sqrt(mean(resym.^2))
outtab(:,2)=[rmsresym totpwrrat/coff-1]';
subplot(2,2,2), semilogy(tax,abs(resym),'bx-','markersize',4,'linewidth',5), ylim([1e-4 1e-1])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

% offset central frequency
om1=1.0127  % for sigma = sqrt(pi)
%om1=1.004   % for sigma = sqrt(pi)*2 ?
[ym,fax,dfax,taumax]=osdmorlet(1,yt,tax,nf,sigma,tau,pf,om1);
pwrym=abs(ym).^2; phsym=angle(ym);
iym=osdmorlet(-1,ym,tax,nf,sigma,tau,pf,om1);
resym=(iym-yt); rmsresym=sqrt(mean(resym.^2))
totpwr=[sumyt2 dfax*sum(pwrym,2) sum(iym.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
outtab(:,3)=[rmsresym totpwrrat-1]';
subplot(2,2,3), semilogy(tax,abs(resym),'bx-','markersize',4,'linewidth',5), ylim([1e-6 1e-3])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

% offset central frequency and invert power ratios
coff=sqrt(prod(totpwrrat))
iym=iym/coff;
resym=(iym-yt); rmsresym=sqrt(mean(resym.^2))
outtab(:,4)=[rmsresym totpwrrat/coff-1]';
subplot(2,2,4), semilogy(tax,abs(resym),'bx-','markersize',4,'linewidth',5), ylim([1e-6 1e-3])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

outtab
for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figF.eps')
system('epstopdf figF.eps');
delete temp.eps

outtabsho=[['$\langle r^2(t) \rangle_t^{1/2}$ ';'$E_{\hat{Y}} / E_y - 1$ ';'$E_{\hat{\hat{y}}} / E_{\hat{Y}} - 1$ '], num2str(outtab,' & %5.4e'), [' \\';' \\';' \\']]
fid = fopen ("tabB.tex", "w");
fdisp (fid, outtabsho);
fclose (fid);

disp(' '), disp('figG')
pappos=[2 2 6 4]
figure(5), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;
%sigma = sqrt(pi)*2, tau = 6*2

format long
yt=yt+myt; sumyt2=sum(yt.^2)    % restore the signal mean
sigma = sigma/tau, tau = [12:48*2]
taumax = max(tau); taumin=min(tau);
%sigma = sigma*tau/max(tau), tau = max(tau)
[yl,fax,dfax,phi]=osdlayer(1,yt,tax,nf,sigma,tau,pf);
pwryl=abs(yl).^2; phsyl=angle(yl);
iyl=osdlayer(-1,yl,tax,nf,sigma,tau,pf);
resyl=(iyl-yt); rmsresyl=sqrt(mean(resyl.^2))
totpwr=[sumyt2 dfax*sum(pwryl,2) sum(iyl.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),1:length(phi),nf,1); 
pwrphif2=abs(phif2).^2; 
cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
convpwrf=cvp(nf*3+[1:nff])*2;
convpwrt=conv(phi.^2/2,yt.^2);

taxtau=1-taumax:nt+taumax;
subplot(2,2,1), [cp,ch]=contour(taxtau,fax,pwryl); axis([1-taumin nt+taumin 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)
subplot(2,2,2), ph=plot(sum(pwryl,2),fax,'bx',convpwrf,fax,'r+'); ylim([0 1/2])
xlim([0 800*ceil(max(sum(pwryl,2))/800)]), set(gca,'XTick',0:800:max(xlim))
xlabel('P(f)','fontsize',fsze), ylabel('f','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,3), ph=plot(taxtau,dfax*pwryl,'bx',taxtau,convpwrt,'r+'); xlim([1-taumin nt+taumin])
xlabel('t','fontsize',fsze), ylabel('P(t)','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,4), semilogy(tax,abs(resyl),'bx-','markersize',4,'linewidth',5), ylim([1e-17 1e-14])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figG.eps')
system('epstopdf figG.eps');
delete temp.eps

figure(6), 
subplot(2,2,4), plot(fax,sum(pwryl,2),'bx','markersize',4,'linewidth',5), xlim([0 1/2])
ylim([0 800*ceil(max(sum(pwryl,2))/800)]), set(gca,'YTick',0:800:max(ylim))

disp(' '), disp('figH')
for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    xlabel('f','fontsize',fsze), ylabel('P(f)','fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[mod(ks+1,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figH.eps')
system('epstopdf figH.eps');
delete temp.eps

diary off

