% script for testing one sided transforms

clear all, close all

diary off
dfile='figsec5.txt'
delete(dfile)
diary(dfile)

disp(' '), disp('irregular layered window transform')

load savesig.mat    % load previous signal
taxrm = randperm(nt-2)+1; taxrm=taxrm(1:66)
tgap = tax; tgap(taxrm) = [];
ygap = yt; ygap(taxrm) = [];
yt0 = yt; yt0(taxrm) = 0;
sumyt2 = sum(ygap.^2);  % new energy
gcddt = gcd(diff(tgap)), if gcddt>1, disp('break'), pause, end
%plot(tax,yt,'+-',tgap,ygap,'ro')

disp(' '), disp('figI')
pappos=[2 2 6 4]
figure(7), clf, set(gcf,'paperposition',pappos,'position',pappos*100), drawnow, pause(2)
fsze=24;
%sigma = sqrt(pi)*2, tau = 6*2

format long
[yf2,fax2,dfax2]=tsdfourier(1,ygap,tgap,nf,pf);
pwryf2=abs(yf2).^2; phsyf2=angle(yf2);
iyf2=real(tsdfourier(-1,yf2,tgap,nf,pf));
resyf2=(iyf2.'-ygap); rmsresyf2=sqrt(mean(resyf2.^2))
[sum(iyf2.^2) dfax2*pwryf2 sumyt2], ans(2:3)./ans(1:2), 1./ans
format short

format long
sigma = sqrt(pi)/6, tau = [12:48*2]
taumax = max(tau); taumin=min(tau);
%sigma = sigma*tau/max(tau), tau = max(tau)
[yl,fax,dfax,phi]=osdlayer(1,ygap,tgap,nf,sigma,tau,pf);
pwryl=abs(yl).^2; phsyl=angle(yl);
iyl=osdlayer(-1,yl,tgap,nf,sigma,tau,pf);
resyl=(iyl-ygap); rmsresyl=sqrt(mean(resyl.^2))
totpwr=[sumyt2 dfax*sum(pwryl,2) sum(iyl.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),1:length(phi),nf,1); 
pwrphif2=abs(phif2).^2; 
cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
convpwrf=cvp(nf*3+[1:nff])*2;
convpwrt=conv(phi.^2/2,yt0.^2);

taxtau=1-taumax:nt+taumax;
subplot(2,2,1), [cp,ch]=contour(taxtau,fax,pwryl); axis([1-taumin nt+taumin 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)
subplot(2,2,2), ph=plot(sum(pwryl,2),fax,'bx',convpwrf,fax,'r+'); ylim([0 1/2])
xlim([0 400*ceil(max(sum(pwryl,2))/400)]), set(gca,'XTick',0:400:max(xlim))
xlabel('P(f)','fontsize',fsze), ylabel('f','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,3), ph=plot(taxtau,dfax*pwryl,'bx',taxtau,convpwrt,'r+'); xlim([1-taumin nt+taumin])
xlabel('t','fontsize',fsze), ylabel('P(t)','fontsize',fsze), set(ph,'markersize',4,'linewidth',5)
subplot(2,2,4), semilogy(tgap,abs(resyl),'bx-','markersize',4,'linewidth',5), ylim([1e-17 1e-14])
xlabel('t','fontsize',fsze), ylabel('|r(t)|','fontsize',fsze), 

for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figI.eps')
system('epstopdf figI.eps');
delete temp.eps

diary off

