% script for testing one sided transforms

clear all, close all

diary off
dfile='figsec6.txt'
delete(dfile)
diary(dfile)

disp(' '), disp('figK and figL and tabF')
pappos=[2 2 6 6]
figure(1), clf, set(gcf,'paperposition',pappos,'position',(pappos-[1 1 0 0])*100), drawnow, pause(2)
pappos=[2 2 6 4]
figure(2), clf, set(gcf,'paperposition',pappos,'position',(pappos-[1 1 0 0])*100), drawnow, pause(2)
fsze=24;

disp(' '), disp('comparison of leakage functions')

load savesig.mat    % load previous signal
yt = yt/sqrt(sum(yt.^2));   % normalize to unit energy
sumyt2 = sum(yt.^2)

% generate new signal

nd=200, tax=1:nd; 
%tax=cumsum(round(3*rand(1,nd)))+tax; tax=tax-tax(1)+1; % make tax gapped
nt=tax(end)
nq=4
%fq=sort(rand(nq,1)*.5)
fq=linspace(.05,.45,nq)';
aq=2*pi*rand(nq,1)*ones(1,nd);
fq=fq(:,ones(1,nd)).*(1+.1*cos(aq+4*pi*tax(ones(1,nq),:)/nd));
fq(fq>1/2)=1-fq(fq>1/2); fq(fq<0)=-fq(fq<0);
aq=2*pi*rand(nq,1)*ones(1,nd);
shoax=round(linspace(1,nt,41)); shoax=shoax(1:2:41);
ytc=cos(aq+2*pi*fq.*tax(ones(1,nq),:));
ytc([1 3],1:100)=0; ytc([2 4],101:200)=0; yt=sum(ytc,1);
myt=mean(yt)
sumyt2=sum(yt.^2)
fq([1 3],1:100)=nan; fq([2 4],101:200)=nan;

pf = 0
nf = nt/2
nff = nf+pf

format long
[yf1,fax1,dfax1]=osdfourier(1,yt,tax,nf,pf);
pwryf1=abs(yf1).^2; phsyf1=angle(yf1);
iyf1=osdfourier(-1,yf1,tax,nf,pf);
resyf1=(iyf1.'-yt); rmsresyf1=sqrt(mean(resyf1.^2))
[sum(iyf1.^2) dfax1*pwryf1 sumyt2], ans(2:3)./ans(1:2), 1./ans
format short

format long
[yf2,fax2,dfax2]=tsdfourier(1,yt,tax,nf,pf);
pwryf2=abs(yf2).^2; phsyf2=angle(yf2);
iyf2=real(tsdfourier(-1,yf2,tax,nf,pf));
resyf2=(iyf2.'-yt); rmsresyf2=sqrt(mean(resyf2.^2))
[sum(iyf2.^2) dfax2*pwryf2 sumyt2], ans(2:3)./ans(1:2), 1./ans
format short

disp(' '), disp('Gabor')

format long
sigma = sqrt(pi)*2, tau = 6*2
[yg,fax,dfax,phi]=osdgabor(1,yt,tax,nf,sigma,tau,pf);
pwryg=abs(yg).^2; phsyg=angle(yg);
iyg=osdgabor(-1,yg,tax,nf,sigma,tau,pf);
resyg=(iyg-yt); rmsresyg=sqrt(mean(resyg.^2))
totpwr=[sumyt2 dfax*sum(pwryg,2) sum(iyg.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
taxphi=-tau:tau;
[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),taxphi,nf,1); 
pwrphif2=abs(phif2).^2; pwrphit=phi.^2/2; phinrg=[sum(pwrphit) dfaxphi*pwrphif2]
t1=sum(taxphi.*pwrphit), t2=sqrt(sum((taxphi-t1).^2.*pwrphit))
f1=dfaxphi*diag(faxphi)*pwrphif2, f2=sqrt(dfaxphi*diag(faxphi-f1)^2*pwrphif2)
bwppi4=t2*f2*4*pi, outtab=[t1 t2 f1 f2 bwppi4 rmsresyg];
outtabsho=['Gabor & $2 \sqrt{\pi}$ & $12$ ' num2str(outtab,' & %5.3f') ' \\']
fid = fopen ("tabF.tex", "w"); fdisp (fid, outtabsho); fclose (fid);
cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
convpwrf=cvp(nf*3+[1:nff])*2;
convpwrt=conv(phi.^2/2,yt.^2);
figure(1), 
subplot(4,2,1), plot(taxphi,pwrphit,'bx','markersize',4,'linewidth',5), 
axis([-15 15 0 0.3]), set(gca,'YTick',0:.1:.3)
subplot(4,2,2), plot(faxphi,pwrphif2,'bx','markersize',4,'linewidth',5), 
axis([-1/2 1/2 0 8]), set(gca,'XTick',-.5:.25:.5,'YTick',0:2:8)
figure(2), taxtau=1-tau:nt+tau;
subplot(2,2,1), [cp,ch]=contour(taxtau,fax,pwryg); axis([1-12 nt+12 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)

disp(' '), disp('Gabor')

format long
%sigma = sqrt(pi)*2*i, tau = 6*2
sigma = sqrt(pi)*16, tau = 6*16
[yg,fax,dfax,phi]=osdgabor(1,yt,tax,nf,sigma,tau,pf);
pwryg=abs(yg).^2; phsyg=angle(yg);
iyg=osdgabor(-1,yg,tax,nf,sigma,tau,pf);
resyg=(iyg-yt); rmsresyg=sqrt(mean(resyg.^2))
totpwr=[sumyt2 dfax*sum(pwryg,2) sum(iyg.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
taxphi=-tau:tau;
[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),taxphi,nf,1); 
pwrphif2=abs(phif2).^2; pwrphit=phi.^2/2; phinrg=[sum(pwrphit) dfaxphi*pwrphif2]
t1=sum(taxphi.*pwrphit), t2=sqrt(sum((taxphi-t1).^2.*pwrphit))
f1=dfaxphi*diag(faxphi)*pwrphif2, f2=sqrt(dfaxphi*diag(faxphi-f1)^2*pwrphif2)
bwppi4=t2*f2*4*pi, outtab=[t1 t2 f1 f2 bwppi4 rmsresyg];
%outtabsho=['Gabor & $i 2 \sqrt{\pi}$ & $12$ ' num2str(outtab,' & %5.3f') ' \\']
outtabsho=['Gabor & $16 \sqrt{\pi}$ & $96$ ' num2str(outtab,' & %5.3f') ' \\']
fid = fopen ("tabF.tex", "a"); fdisp (fid, outtabsho); fclose (fid);
cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
convpwrf=cvp(nf*3+[1:nff])*2;
convpwrt=conv(phi.^2/2,yt.^2);
figure(1), 
subplot(4,2,3), plot(taxphi,pwrphit,'bx','markersize',4,'linewidth',5), 
%axis([-15 15 0 0.5])
axis([-100 100 0 0.04]), set(gca,'YTick',0:.01:.04)
subplot(4,2,4), plot(faxphi,pwrphif2,'bx','markersize',4,'linewidth',5), 
axis([-1/2 1/2 0 60]), set(gca,'XTick',-.5:.25:.5,'YTick',0:20:60)
figure(2), taxtau=1-tau:nt+tau;
subplot(2,2,2), [cp,ch]=contour(taxtau,fax,pwryg); axis([1-12 nt+12 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)

disp(' '), disp('Layered')

format long
sigma = sqrt(pi)/6, tau = [12:48*2]
taumax = max(tau); taumin=min(tau);
%sigma = sigma*tau/max(tau), tau = max(tau)
[yl,fax,dfax,phi]=osdlayer(1,yt,tax,nf,sigma,tau,pf);
pwryl=abs(yl).^2; phsyl=angle(yl);
iyl=osdlayer(-1,yl,tax,nf,sigma,tau,pf);
resyl=(iyl-yt); rmsresyl=sqrt(mean(resyl.^2))
totpwr=[sumyt2 dfax*sum(pwryl,2) sum(iyl.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
taxphi=-taumax:taumax;
[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),taxphi,nf,1); 
pwrphif2=abs(phif2).^2; pwrphit=phi.^2/2; phinrg=[sum(pwrphit) dfaxphi*pwrphif2]
t1=sum(taxphi.*pwrphit), t2=sqrt(sum((taxphi-t1).^2.*pwrphit))
f1=dfaxphi*diag(faxphi)*pwrphif2, f2=sqrt(dfaxphi*diag(faxphi-f1)^2*pwrphif2)
bwppi4=t2*f2*4*pi, outtab=[t1 t2 f1 f2 bwppi4 rmsresyl];
outtabsho=['Layered & $\sqrt{\pi} / 6$ & $[12, 96]$ ' num2str(outtab,' & %5.3f') ' \\']
fid = fopen ("tabF.tex", "a"); fdisp (fid, outtabsho); fclose (fid);
cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
convpwrf=cvp(nf*3+[1:nff])*2;
convpwrt=conv(phi.^2/2,yt.^2);
figure(1), 
subplot(4,2,5), plot(taxphi,pwrphit,'bx','markersize',4,'linewidth',5), 
axis([-100 100 0 0.1])
subplot(4,2,6), plot(faxphi,pwrphif2,'bx','markersize',4,'linewidth',5), 
axis([-1/2 1/2 0 40]), set(gca,'XTick',-.5:.25:.5,'YTick',0:10:40)
figure(2), taxtau=1-taumax:nt+taumax;
subplot(2,2,3), [cp,ch]=contour(taxtau,fax,pwryl); axis([1-12 nt+12 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)

%disp(' '), disp('Cauchy')

%format long
%sigma = 6/sqrt(pi), tau = 6*16
%taxphi=-tau:tau;
%phi=sqrt(1./(1+taxphi.^2/sigma^2));
%[yg,fax,dfax,phi]=osdgiven(1,yt,tax,nf,phi,pf);
%pwryg=abs(yg).^2; phsyg=angle(yg);
%iyg=osdgiven(-1,yg,tax,nf,phi,pf);
%resyg=(iyg-yt); rmsresyg=sqrt(mean(resyg.^2))
%totpwr=[sumyt2 dfax*sum(pwryg,2) sum(iyg.^2)]
%totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
%format short
%[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),taxphi,nf,1); 
%pwrphif2=abs(phif2).^2; pwrphit=phi.^2/2; phinrg=[sum(pwrphit) dfaxphi*pwrphif2]
%t1=sum(taxphi.*pwrphit), t2=sqrt(sum((taxphi-t1).^2.*pwrphit))
%f1=dfaxphi*diag(faxphi)*pwrphif2, f2=sqrt(dfaxphi*diag(faxphi-f1)^2*pwrphif2)
%bwppi4=t2*f2*4*pi, outtab=[t1 t2 f1 f2 bwppi4 rmsresyg];
%outtabsho=['Cauchy & $6 / \sqrt{\pi}$ & $96$ ' num2str(outtab,' & %5.3f') ' \\']
%fid = fopen ("tabF.tex", "a"); fdisp (fid, outtabsho); fclose (fid);
%cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
%convpwrf=cvp(nf*3+[1:nff])*2;
%convpwrt=conv(phi.^2/2,yt.^2);
%figure(1), 
%subplot(4,2,5), plot(taxphi,pwrphit,'bx','markersize',4,'linewidth',5), 
%axis([-30 30 0 0.06]), set(gca,'YTick',0:.02:.06)
%subplot(4,2,6), plot(faxphi,pwrphif2,'bx','markersize',4,'linewidth',5), 
%axis([-1/2 1/2 0 40]), set(gca,'XTick',-.5:.25:.5,'YTick',0:10:40)
%figure(2), taxtau=1-tau:nt+tau;
%subplot(2,2,3), [cp,ch]=contour(taxtau,fax,pwryg); axis([1-12 nt+12 0 1/2]), set(ch,'linewidth',4)
%hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
%xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)

disp(' '), disp('Random')

format long
tau = 24, phi=rand(1,2*tau+1);
[yg,fax,dfax,phi]=osdgiven(1,yt,tax,nf,phi,pf);
pwryg=abs(yg).^2; phsyg=angle(yg);
iyg=osdgiven(-1,yg,tax,nf,phi,pf);
resyg=(iyg-yt); rmsresyg=sqrt(mean(resyg.^2))
totpwr=[sumyt2 dfax*sum(pwryg,2) sum(iyg.^2)]
totpwrrat=totpwr(2:3)./totpwr(1:2), 1./totpwrrat, 1-totpwrrat
format short
taxphi=-tau:tau;
[phif2,faxphi,dfaxphi]=tsdfourier(1,phi/sqrt(2),taxphi,nf,1); 
pwrphif2=abs(phif2).^2; pwrphit=phi.^2/2; phinrg=[sum(pwrphit) dfaxphi*pwrphif2]
t1=sum(taxphi.*pwrphit), t2=sqrt(sum((taxphi-t1).^2.*pwrphit))
f1=dfaxphi*diag(faxphi)*pwrphif2, f2=sqrt(dfaxphi*diag(faxphi-f1)^2*pwrphif2)
bwppi4=t2*f2*4*pi, outtab=[t1 t2 f1 f2 bwppi4 rmsresyg];
outtabsho=['Random & --- & $24$ ' num2str(outtab,' & %5.3f') ' \\']
fid = fopen ("tabF.tex", "a"); fdisp (fid, outtabsho); fclose (fid);
cvp=conv(dfaxphi'.*pwrphif2,[pwryf2(nf+[1:nf]); pwryf2; pwryf2([1:nf]+pf)]); 
convpwrf=cvp(nf*3+[1:nff])*2;
convpwrt=conv(phi.^2/2,yt.^2);
figure(1), 
subplot(4,2,7), plot(taxphi,pwrphit,'bx','markersize',4,'linewidth',5), 
axis([-30 30 0 0.06]), set(gca,'YTick',0:.02:.06)
subplot(4,2,8), plot(faxphi,pwrphif2,'bx','markersize',4,'linewidth',5), 
axis([-1/2 1/2 0 40]), set(gca,'XTick',-.5:.25:.5,'YTick',0:10:40)
figure(2), taxtau=1-tau:nt+tau;
subplot(2,2,4), [cp,ch]=contour(taxtau,fax,pwryg); axis([1-12 nt+12 0 1/2]), set(ch,'linewidth',4)
hold on, plot(tax,fq,'k-','linewidth',6,tax(shoax),fq(:,shoax),'ws','markersize',2), hold off, 
xlabel('t','fontsize',fsze), ylabel('f','fontsize',fsze)

figure(1)
for ks=1:8, subplot(4,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    
    if mod(ks,2), xlabel('t\prime','fontsize',fsze), ylabel('Window','fontsize',fsze), 
    else  , xlabel('f_\Delta','fontsize',fsze), ylabel('Leakage','fontsize',fsze), end
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1.25-2*mod(ks,2) (2.5-ceil(ks/2))/2 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figK.eps');
system('epstopdf figK.eps');
delete temp.eps

figure(2)
for ks=1:4, subplot(2,2,ks)
    set(gca,'linewidth',2,'fontsize',fsze)
    text(1.02,0.95,['(' char(96+ks) ')'],'units','normalized','verticalalignment','top','fontsize',fsze)
    apos=get(gca,'position'); apos=apos+.04*[1-2*mod(ks,2) 0 0 0]; set(gca,'position',apos)
end
print('temp.eps','-depsc2',['-F:' num2str(fsze-4)])
system('eps2eps temp.eps figL.eps')
system('epstopdf figL.eps');
delete temp.eps

diary off
