% script for testing one sided transforms

clear all, close all

diary off
dfile='tabsec5.txt'
delete(dfile)
diary(dfile)

% signal generation
nd=10, tax=1:nd; 
gmin=2, gsprd=2     % make tax gapped
tax=cumsum(round(gsprd*rand(1,nd)))+tax*gmin; 
tax=(tax-tax(1))/gcd(diff(tax))+1;
tax=[1    4    7   10   13   15   18   21   25   28]
nt=tax(end)
gcddt=gcd(diff(tax)), 
nq=4
%fq=sort(rand(nq,1)*.5)
fq=linspace(.05,.30,nq)';
aq=2*pi*rand(nq,1)*ones(1,nd);
fq=fq(:,ones(1,nd)).*(1+.05*cos(aq+2*pi*tax(ones(1,nq),:)/nd));
fq(fq>1/2)=1-fq(fq>1/2); fq(fq<0)=-fq(fq<0);
aq=2*pi*rand(nq,1)*ones(1,nd);
shoax=round(linspace(1,nt,41)); shoax=shoax(1:2:41);
yt=sum(cos(aq+2*pi*fq.*tax(ones(1,nq),:)),1);
sumyt2=sum(yt.^2)
myt=mean(yt)
ygap=zeros(1,nt); ygap(tax)=yt; 

figure(1), clf
hist(diff(tax),[0:gsprd]+gmin)

figure(2), clf
plot(tax,yt,'s-')

disp(' '), disp('find minimal Fourier order')

pf = 0
outtab = zeros(3,10); ot = 0;
for nf = ceil(nd/2):ceil(nt/2), disp(' '), nf
%for nf = 1:ceil(nt/2), disp(' '), nf
nff = nf+pf
format long
[yf,fax,dfax]=osdfourier(1,yt,tax,nf,pf);
pwryf=abs(yf).^2; phsyf=angle(yf);
iyf=osdfourier(-1,yf,tax,nf,pf);
resyf=(iyf.'-yt); rmsresyf=sqrt(mean(resyf.^2)); normres=norm(resyf)
pwrratf=dfax*pwryf/sumyt2-1
pwrrati=sum(iyf.^2)/(dfax*pwryf)-1
format short
theta = exp(i*2*pi*tax(:)*fax);    % basis functions
Qmat = real(theta*diag(dfax)*theta'*2);
willitwork = norm(Qmat-eye(nd),'fro')
ot = ot+1; outtab(:,ot) = [nf; normres; willitwork];
end % for nf
outtabsho=[['$N$ ' num2str(outtab(1,1:5),' & \\multicolumn{1}{c}{%i}') ' \\ \hline']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab(2:3,1:5),' & %5.4e'), [' \\';' \\ \hline']];
outtabsho=[outtabsho; ['$N$ ' num2str(outtab(1,6:10),' & \\multicolumn{1}{c}{%i}') ' \\ \hline']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab(2:3,6:10),' & %5.4e'), [' \\';' \\']]
fid = fopen ("tabC.tex", "w");
fdisp (fid, outtabsho);
fclose (fid);

disp(' '), disp('gapped')
% signal generation
nd=30, nt=100
rpn=randperm(nt-2)+1;
tax=[1 sort(rpn(1:nd-2)) nt]
nq=4
fq=linspace(.05,.30,nq)';
aq=2*pi*rand(nq,1)*ones(1,nd);
fq=fq(:,ones(1,nd)).*(1+.05*cos(aq+2*pi*tax(ones(1,nq),:)/nd));
fq(fq>1/2)=1-fq(fq>1/2); fq(fq<0)=-fq(fq<0);
aq=2*pi*rand(nq,1)*ones(1,nd);
shoax=round(linspace(1,nt,41)); shoax=shoax(1:2:41);
yt=sum(cos(aq+2*pi*fq.*tax(ones(1,nq),:)),1);
sumyt2=sum(yt.^2);
myt=mean(yt);

disp(' '), disp('find minimal Gabor order')
sigma = sqrt(pi)*2, tau = 6*2
tw = -tau:tau;                  % window time axis
phi = exp(-pi*tw.^2/sigma^2/2); % window amplitude
phi = phi/sqrt(phi*phi'/2);     % normalized to unit energy x 2
tbphi = sqrt(phi*diag(tw.^2)*phi'/2)
twphi = 2*tau+1
tbsig = sqrt(mean((tax-mean(tax)).^2))
pf = 0
outtab1 = zeros(3,10); ot = 0;
%for nf = ceil(nd/2):ceil(nt/2), disp(' '), nf
for nf = 6:ceil(nd/2), disp(' '), nf
nff = nf+pf
format long
[yg,fax,dfax]=osdgabor(1,yt,tax,nf,sigma,tau,pf);
pwryg=abs(yg).^2; phsyg=angle(yg);
iyg=osdgabor(-1,yg,tax,nf,sigma,tau,pf);
resyg=(iyg-yt); rmsresyg=sqrt(mean(resyg.^2)); normres=norm(resyg)
%pwrratf=dfax*sum(pwryg,2)/sumyt2-1
%pwrrati=sum(iyg.^2)/(dfax*sum(pwryg,2))-1
psid=exp(-i*2*pi*fax'*tw)*diag(phi); psimat=psid.'*diag(dfax)*psid; [T1,T2]=ndgrid(tw,tw); tmat=T1+T2;
for tm=-2*tau:2*tau, psivec(tm+twphi)=sum(psimat(find(tmat==tm))); end, psivec=real(psivec);
%uvec=zeros(1,4*tau+1); uvec(twphi)=1; willitwork=sqrt(sum((psivec-uvec).^2))
dmax=min(nt-1,2*tau); 
toecol=[psivec(twphi+[0:-1:-dmax]) zeros(1,nt-dmax-1)]; 
toerow=[psivec(twphi+[0:dmax]) zeros(1,nt-dmax-1)];
Q=toeplitz(toecol,toerow); Q=Q(tax,tax); willitwork = norm(Q-eye(nd),'fro')
ot = ot+1; outtab1(:,ot) = [nf; normres; willitwork];
format short
end % for nf

disp(' '), disp('find minimal Gabor order')
sigma = sqrt(pi)*2*2, tau = 6*2
tw = -tau:tau;                  % window time axis
phi = exp(-pi*tw.^2/sigma^2/2); % window amplitude
phi = phi/sqrt(phi*phi'/2);     % normalized to unit energy x 2
tbphi = sqrt(phi*diag(tw.^2)*phi'/2)
twphi = 2*tau+1
tbsig = sqrt(mean((tax-mean(tax)).^2))
pf = 0
outtab2 = zeros(3,10); ot = 0;
%for nf = ceil(nd/2):ceil(nt/2), disp(' '), nf
for nf = 6:ceil(nd/2), disp(' '), nf
nff = nf+pf
format long
[yg,fax,dfax]=osdgabor(1,yt,tax,nf,sigma,tau,pf);
pwryg=abs(yg).^2; phsyg=angle(yg);
iyg=osdgabor(-1,yg,tax,nf,sigma,tau,pf);
resyg=(iyg-yt); rmsresyg=sqrt(mean(resyg.^2)); normres=norm(resyg)
%pwrratf=dfax*sum(pwryg,2)/sumyt2-1
%pwrrati=sum(iyg.^2)/(dfax*sum(pwryg,2))-1
psid=exp(-i*2*pi*fax'*tw)*diag(phi); psimat=psid.'*diag(dfax)*psid; [T1,T2]=ndgrid(tw,tw); tmat=T1+T2;
for tm=-2*tau:2*tau, psivec(tm+twphi)=sum(psimat(find(tmat==tm))); end, psivec=real(psivec);
%uvec=zeros(1,4*tau+1); uvec(twphi)=1; willitwork=sqrt(sum((psivec-uvec).^2))
dmax=min(nt-1,2*tau); 
toecol=[psivec(twphi+[0:-1:-dmax]) zeros(1,nt-dmax-1)]; 
toerow=[psivec(twphi+[0:dmax]) zeros(1,nt-dmax-1)];
Q=toeplitz(toecol,toerow); Q=Q(tax,tax); willitwork = norm(Q-eye(nd),'fro')
ot = ot+1; outtab2(:,ot) = [nf; normres; willitwork];
format short
end % for nf

outtabsho=[['$N$ ' num2str(outtab1(1,1:5),' & \\multicolumn{1}{c}{%i}') ' \\ \hline']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab1(2:3,1:5),' & %5.4e'), [' \\';' \\ \cline{2-7}']];
outtabsho=[outtabsho; ['$N$ ' num2str(outtab1(1,6:10),' & \\multicolumn{1}{c}{%i}') ' \\ \cline{2-7}']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab1(2:3,6:10),' & %5.4e'), [' \\';' \\ \hline']];
outtabsho=[outtabsho; ['$N$ ' num2str(outtab2(1,1:5),' & \\multicolumn{1}{c}{%i}') ' \\ \hline']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab2(2:3,1:5),' & %5.4e'), [' \\';' \\ \cline{2-7}']];
outtabsho=[outtabsho; ['$N$ ' num2str(outtab2(1,6:10),' & \\multicolumn{1}{c}{%i}') ' \\ \cline{2-7}']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab2(2:3,6:10),' & %5.4e'), [' \\';' \\']];
outtabsho=[['$\sigma$ & ';'\multirow{5}{*}{$2 \sqrt{\pi}$} & ';' & ';' & ';' & ';' & ';'$\sigma$ & ';'\multirow{5}{*}{$4 \sqrt{\pi}$} & ';' & ';' & ';' & ';' & '], outtabsho]
fid = fopen ("tabD.tex", "w");
fdisp (fid, outtabsho);
fclose (fid);

disp(' '), disp('find Morlet Q factor')
tax=1:nd; nt=nd;   % resume regular sampling
sigma = sqrt(pi), tau = 6
pf = 0
outtab = zeros(3,10); ot = 0;
for nf = 6:15, disp(' '), nf
nff = nf+pf;
[ym,fax,dfax,taumax]=osdmorlet(1,yt,tax,nf,sigma,tau,pf);
pwrym=abs(ym).^2; phsym=angle(ym);
iym=osdmorlet(-1,ym,tax,nf,sigma,tau,pf);
resym=(iym-yt); rmsresym=sqrt(mean(resym.^2)); normres=norm(resym)
flo = fax(1+pf);            % lowest nonzero frequency
tw = -taumax:taumax;
twphi = 2*taumax+1
phimat = exp(-pi/2/sigma^2*tw'.^2*fax.^2);
phinrg = sum(phimat.^2,1);
phimat = phimat*diag(1./sqrt(phinrg))*sqrt(2);
theta = exp(i*2*pi*tw'*fax);
psid = (phimat.*theta)'; psimat=psid.'*diag(dfax)*psid; [T1,T2]=ndgrid(tw,tw); tmat=T1+T2;
%psibas = phimat.*theta; psibas = psibas-ones(twphi,1)*mean(psibas,1);
%psinrg = sum(abs(psibas).^2,1); psibas = psibas*diag(1./sqrt(psinrg))*sqrt(2);
%psid = (psibas)'; psimat=psid.'*diag(dfax)*psid; [T1,T2]=ndgrid(tw,tw); tmat=T1+T2;
for tm=-2*taumax:2*taumax, psivec(tm+twphi)=sum(psimat(find(tmat==tm))); end, psivec=real(psivec);
dmax=min(nt-1,2*taumax); 
toecol=[psivec(twphi+[0:-1:-dmax]) zeros(1,nt-dmax-1)]; 
toerow=[psivec(twphi+[0:dmax]) zeros(1,nt-dmax-1)];
Q=toeplitz(toecol,toerow); willitwork = norm(Q-eye(nd),'fro')
ot = ot+1; outtab(:,ot) = [nf; normres; willitwork];
end % for nf
outtabsho=[['$N$ ' num2str(outtab(1,1:5),' & \\multicolumn{1}{c}{%i}') ' \\ \hline']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab(2:3,1:5),' & %5.4e'), [' \\';' \\ \hline']];
outtabsho=[outtabsho; ['$N$ ' num2str(outtab(1,6:10),' & \\multicolumn{1}{c}{%i}') ' \\ \hline']; ['$\norm{\mbf{r}}_F$ ';'$\norm{\msf{Q} - \msf{I}_D}_F$ '], num2str(outtab(2:3,6:10),' & %5.4e'), [' \\';' \\']]
fid = fopen ("tabE.tex", "w");
fdisp (fid, outtabsho);
fclose (fid);

